Subject: Re: [PATCH v2 4/7] [PATCH 4/8] can: Driver for the SJA1000 CAN controller

From: Wolfgang Grandegger <[email-masked]>
Date: Fri, 15 May 2009 23:24:17 +0200

Jonathan Corbet wrote:
> On Thu, 14 May 2009 11:03:53 +0200
> Wolfgang Grandegger <[email-masked]> wrote:
> 
>>> So you're still using the "put the higher-level structure at the top so we
>>> can treat it like either kind of pointer" trick.  I'd still recommend
>>> against that.  Far better to do something like:
>>>
>>> 	struct can_priv *canpriv = netdev_priv(dev);
>>> 	struct sja_1000_priv *priv = container_of(canpriv, struct sja_1000_priv, can);
>>>
>>> Of course, you can put that dance into a helper function.  
>> There is no way to initialize the value returned by netdev_priv() as it
>> does not point to a member of struct net_device. I already commented here:
>>
>>   http://marc.info/?l=linux-netdev&m=124120212106891&w=2
>>
>> Have I missed something?
> 
> I'm confused.  It points to the struct can_priv that you registered at
> the beginning.  Since that structure is contained within struct
> sja1000_priv, you can use container_of(), as described above, to get
> it.
> 
> I would probably just write something like:
> 
> static inline struct sja1000_priv *to_sja1000_priv(struct net_device *dev)
> {
> 	return container_of(netdev_priv(dev), struct sja1000_priv, can);
> }
> 
> So have *I* missed something?

Furthermore, the higher layer needs to known the location of the member
"struct sja1000_priv can", e.g. by defining:

  dev->priv = &dev_specific_priv->can;

But "struct net_device" does not have a "priv" member. netdev_priv(dev)
always points to the beginning of the private data area. See:

   http://lxr.linux.no/linux+v2.6.29/include/linux/netdevice.h#L953

Wolfgang.